"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.definition = void 0;
exports.definition = {
    id: 'lemonhd',
    name: 'LemonHD',
    description: 'LemonHD is a CHINESE Private Torrent Tracker for HD MOVIES / TV',
    language: 'zh-CN',
    type: 'private',
    encoding: 'UTF-8',
    links: ['https://lemonhd.org/'],
    legacylinks: ['https://leaguehd.com/'],
    caps: {
        categorymappings: [
            { id: '300', cat: 'Movies/UHD', desc: 'Movies UHD-4K' },
            { id: '301', cat: 'Movies/UHD', desc: 'Movies 2160p' },
            { id: '420', cat: 'Movies/UHD', desc: 'Movies 2160p REMUX' },
            { id: '401', cat: 'Movies/BluRay', desc: 'Movies Blu-ray' },
            { id: '410', cat: 'Movies/HD', desc: 'Movies 1080p' },
            { id: '415', cat: 'Movies', desc: 'Movies 1080p REMUX' },
            { id: '416', cat: 'Movies/3D', desc: 'Movies 3D' },
            { id: '411', cat: 'Movies/HD', desc: 'Movies 720p' },
            { id: '412', cat: 'Movies/WEB-DL', desc: 'Movies WEB-DL' },
            { id: '413', cat: 'TV/HD', desc: 'Movies HDTV' },
            { id: '417', cat: 'Movies', desc: 'Movies iPad' },
            { id: '414', cat: 'Movies/DVD', desc: 'Movies DVD' },
            { id: '402', cat: 'TV', desc: 'TV Series(电视剧)' },
            { id: '403', cat: 'TV', desc: 'TV Shows(综艺)' },
            { id: '404', cat: 'TV/Documentary', desc: 'Documentaries(纪录片)' },
            { id: '405', cat: 'TV/Anime', desc: 'Animations(动画片)' },
            { id: '406', cat: 'Audio/Video', desc: 'Music Videos(MV)' },
            { id: '408', cat: 'Audio', desc: 'HQ Audio(音乐)' },
            { id: '500', cat: 'Audio', desc: 'Music(无损)' },
            { id: '409', cat: 'Other', desc: 'Video Portray(写真视频)' },
        ],
        modes: {
            search: ['q'],
            'tv-search': ['q', 'season', 'ep', 'imdbid'],
            'movie-search': ['q', 'imdbid'],
            'music-search': ['q'],
            'book-search': ['q'],
        },
    },
    settings: [
        { name: 'username', type: 'text', label: 'Username' },
        { name: 'password', type: 'password', label: 'Password' },
        {
            name: 'freeleech',
            type: 'checkbox',
            label: 'Search freeleech only',
            default: false,
        },
        {
            name: 'sort',
            type: 'select',
            label: 'Sort requested from site',
            default: 4,
            options: { '1': 'title', '4': 'created', '5': 'size', '7': 'seeders' },
        },
        {
            name: 'type',
            type: 'select',
            label: 'Order requested from site',
            default: 'desc',
            options: { desc: 'desc', asc: 'asc' },
        },
        {
            name: 'info_tpp',
            type: 'info',
            label: 'Results Per Page',
            default: 'For best results, change the <b>Torrents per page:</b> setting to <b>100</b> on your account profile.',
        },
    ],
    login: {
        path: 'login.php',
        method: 'form',
        form: 'form[action="takelogin.php"]',
        inputs: {
            username: '{{ .Config.username }}',
            password: '{{ .Config.password }}',
        },
        captcha: {
            type: 'image',
            selector: 'img[src^="image.php?"]',
            input: 'imagestring',
        },
        error: [{ selector: 'table:has(a[href="login.php"])' }],
        test: { path: 'index.php' },
    },
    search: {
        paths: [{ path: 'torrents.php' }],
        inputs: {
            search: '{{ if .Query.IMDBID }}{{ .Query.IMDBID }}{{ else }}{{ .Keywords }}{{ end }}',
            incldead: 0,
            spstate: '{{ if .Config.freeleech }}2{{ else }}0{{ end }}',
            search_area: '{{ if .Query.IMDBID }}4{{ else }}0{{ end }}',
            search_mode: 0,
            sort: '{{ .Config.sort }}',
            type: '{{ .Config.type }}',
        },
        rows: {
            selector: 'table.torrents > tbody > tr:has(table.torrentname)',
        },
        fields: {
            category: {
                selector: 'a[href*="?cat_"]',
                attribute: 'href',
                filters: [{ name: 'regexp', args: 'cat_(\\d{3})' }],
            },
            title: {
                optional: true,
                selector: 'a[title][href^="details_"] > b',
                attribute: 'title',
            },
            details: { selector: 'a[href^="details_"]', attribute: 'href' },
            download: {
                selector: 'a[href^="download.php?"]',
                attribute: 'href',
            },
            imdb: {
                selector: 'a[href*="imdb.com/title/tt"]',
                attribute: 'href',
            },
            date: {
                selector: 'td:nth-child(4):not(:has(span[title])):not(:has(a))',
                optional: true,
                filters: [
                    { name: 'append', args: ' +08:00' },
                    { name: 'dateparse', args: '2006-01-0215:04:05 -07:00' },
                ],
            },
            size: { selector: 'td:nth-child(5)' },
            seeders: { selector: 'td:nth-child(6)' },
            leechers: { selector: 'td:nth-child(7)' },
            grabs: { selector: 'td:nth-child(8)' },
            downloadvolumefactor: {
                case: {
                    'img.pro_free': 0,
                    'img.pro_free2up': 0,
                    'img.pro_50pctdown': 0.5,
                    'img.pro_50pctdown2up': 0.5,
                    'img.pro_30pctdown': 0.3,
                    '*': 1,
                },
            },
            uploadvolumefactor: {
                case: {
                    'img.pro_50pctdown2up': 2,
                    'img.pro_free2up': 2,
                    'img.pro_2up': 2,
                    '*': 1,
                },
            },
            description: { selector: 'td:nth-child(2)', remove: 'a, img' },
        },
    },
    source: 'jackett',
};
